library A2BCD;

uses
  SysUtils,
  Windows,
  Classes,
  Controls,
  DLG_A2BCD in 'DLG_A2BCD.pas';

{$R *.RES}

Const  Inputs = 1;  // number of inputs
       Outputs = 8; // number of outputs made adjustable

       {INPUTS}
       Value   = 0;   // index of input variable

       {OUTPUTS}
       SELECT = 0;

       DLLINDEX = 100;

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

function NumInputs: Byte;
begin
  result:= Inputs; //Define FIXED number of component input pins
end;

function NumOutputs: Byte; // Made adjustable with 'NumOutputsEx'
begin
  result:= Outputs; //Define FIXED number of component output pins
end;

function NumOutputsEx(PUser: PDLLParams): Byte;
begin

end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
   case Channel of
   Value: result:='A_VAL';
   end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
   result:='Q'+intToStr(Channel);
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams); //called when ProfiLab enters RUN mode
begin
  // nothing to be done
//  PUser^[SELECT]:= 0;
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
end;

Procedure Calculate(PInput,POutput,PUser: PDLLParams); //called regularly from ProfiLab
var l_VALUE : longint;
    n,i: Integer;
begin
  l_VALUE:= round(PInput[Value]);
  n:= round(PUser^[SELECT]);

  case n of
  0: begin
     end;
  1: begin
       l_VALUE:= l_VALUE shr  8;
     end;
  2: begin
       l_VALUE:= l_VALUE shr 16;
     end;
  3: begin
       l_VALUE:= l_VALUE shr 24;
     end;
  end; //case


  for i:= 0 to 7 do
  begin
    if (l_VALUE and (1 shl i)) > 0 then POutput^[i]:= 5 else POutput[i]:= 0; //Set binary outputs with current COUNT
   end;
end;

Procedure Configure(PUser: PDLLParams);
var DLG: TA2BCDDLG;
begin
   DLG:=TA2BCDDLG.Create(nil);                       //Create user dialogue
   With DLG do
   begin
      Caption:='Counter [DLL'+FloatToStr(PUser^[DLLIndex])+']'; // Show ProfiLab DLL-Index in dialogue caption
      BitsCombo.ItemIndex:=round(PUser^[SELECT]);       // Set dialogue values

      if ShowModal = mrOK then                                 // Execute dialogue
      begin
         PUser^[SELECT]:= BitsCombo.ItemIndex;           // Read back values from dialogue;
      end;

      free;                                                  // Dont forget to free dialogue
   end;
end;


//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        Calculate,
        InputName,
        OutputName,
        Configure;
begin
end.

